const sequelize = require('./config');
const { DataTypes } = require('sequelize')

const User = sequelize.define('user', {
  // Model attributes
  username: {
    type: DataTypes.STRING,
    allowNull: false,
    unique: true
  },
  password: {
    type: DataTypes.STRING,
    allowNull: false
  },
  role: {
    type: DataTypes.ENUM('customer', 'admin'),
    allowNull: false,
    defaultValue: 'customer',
  }
});

// Sync model with database
User.sync();

module.exports = User;
