var express = require('express');
var router = express.Router();
const model = require('../models')
const jwt = require('jsonwebtoken')

const generateToken = (user) => {
    const {username,id,role} = {...user}
    const payload = {username,id,role};
    return jwt.sign(
      payload, 
      'croxsol', 
      { expiresIn: '7d' });
}


// Define the registration API route
router.post('/register', async (req, res) => {
  try {
    // const { username, password } = req.body;
    console.log(req.body);
    const newUser = await model.User.create(req.body);
    res.status(200).json({ message: 'User created successfully', data: newUser });
  } catch (error) {
    if (error.name === 'SequelizeUniqueConstraintError') {
      res.status(400).json({ error: 'Username already exists' });
    } else {
      console.error('Error creating user:', error);
      res.status(500).json({ error: 'Internal server error' });
    }
  }
});

// Get All Users
router.get('/all', async (req, res) => {
    try {
      // const { username, password } = req.body;
      const users = await model.User.findAll();
      res.status(200).json({ message: 'All users', data: users });
    } catch (error) {
      if (error.name === 'SequelizeUniqueConstraintError') {
        res.status(400).json({ error: 'Username already exists' });
      } else {
        console.error('Error creating user:', error);
        res.status(500).json({ error: 'Internal server error' });
      }
    }
});

// Login
router.post('/login', async (req, res) => {
    try {
        // const { username, password } = req.body;
        const user = await model.User.findOne({where:{username:req.body.username}});
        if (!user) {
            return res.status(401).send({ success: false,
            message: 'Invalid Credentials', });
        }
  
        if (req.body.password !== user.password) {
            return res.status(401).send({ success: false,
            message: 'Invalid Credentials', });
        }
    
        const token = generateToken(user.dataValues)

        res.status(200).send({ 
            success:true,
            message:"Successfully Logged in",
            token 
        });
    } catch (error) {
      if (error.name === 'SequelizeUniqueConstraintError') {
        res.status(400).json({ error: 'Username already exists' });
      } else {
        console.error('Error creating user:', error);
        res.status(500).json({ error: 'Internal server error' });
      }
    }
});

module.exports = router;

